;------------------------------------------------------------
;
; Include file for MON386.ASM
; Copyright (c) 1992-2003,2004 Alessandro Scotti
; http://www.ascotti.org/
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;------------------------------------------------------------
INCLUDE REGS.INC

;------------------------------------------------------------
;
; DR7 debug register
;
DR7REG  RECORD  BP3:4, BP2:4,                   \
                BP1:4, BP0:4,                   \
                NA1:2,GD:1,NA2:3,GEB:1,LEB:1,   \
                G3:1,L3:1,G2:1,L2:1,G1:1,L1:1,G0:1,L0:1

;------------------------------------------------------------
;
; DR6 debug register
;
DR6REG  RECORD  NA3:16,TS:1,BS:1,BD:1,NA4:9,B3:1,B2:1,B1:1,B0:1

;------------------------------------------------------------
;
; Internal flags
;
IFLAGS  RECORD  NA:12,                          \
                FL_RESUME:1,                    \
                FL_STEP:1,                      \
                FL_BREAK:1,                     \
                FL_INIT:1

; Macro to call DOS
.dos    MACRO   function
    IF function LT 100h
        mov     ah, function
    ELSE
        mov     ax, function
    ENDIF
        int     21h
ENDM

; Macro to push registers, variables or flags onto the stack
; Usage: .push "loc16"[,"loc16"...]
; where "loc16" is a 16-bit register, a word-sized variable or the
; keyword "FLAGS".
; Exmpl: .push ax, flags, var1
;        .pop  ax, flags, var1
;
.push   MACRO   r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10
    IFNB <r10>
        .ERROR <.PUSH has more than 10 arguments>
    ENDIF
    IRP $reg, <r0, r1, r2, r3, r4, r5, r6, r7, r8, r9>
        IFB <$reg>                      ;; Is argument blank?
            EXITM                       ;; Yes, exit
        ELSEIFIDNI <$reg>, <FLAGS>      ;; Is argument the keyword "FLAGS"?
            pushf                       ;; Yes, push flags
        ELSE
            push    $reg                ;; Push argument
        ENDIF
    ENDM
ENDM

; Macro to pop registers, variables or flags from the stack
; Usage: .pop "loc16"[,"loc16"...]
; where "loc16" is a 16-bit register, a word-sized variable or the
; keyword "FLAGS".
; Exmpl: .push ax, flags, var1
;        .pop  ax, flags, var1
;
.pop    MACRO   r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10
    IFNB <r10>
        .ERROR <.POP has more than 10 arguments>
    ENDIF
    IRP $reg, <r9, r8, r7, r6, r5, r4, r3, r2, r1, r0>
        IFNB <$reg>                     ;; Is argument non-blank?
            IFIDNI <$reg>, <FLAGS>      ;; Yes, is it the keyword "FLAGS"?
                popf                    ;; Yes, pop flags
            ELSE
                pop     $reg            ;; Pop argument
            ENDIF
        ENDIF
    ENDM
ENDM

; Enter procedure
.enter  MACRO
        push    bp
        mov     bp, sp
ENDM

; Leave procedure
.leave  MACRO
        mov     sp, bp
        pop     bp
ENDM
