(*
    MON386 - A debugging API for the 80386
    Copyright (c) 1992-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit Mon386;
interface

const
  BP_CODE   = $00;
  BP_WBYTE  = $01;
  BP_WWORD  = $05;
  BP_WLONG  = $0D;
  BP_RWBYTE = $03;
  BP_RWWORD = $07;
  BP_RWLONG = $0F;
type
  PMon3Regs = ^TMon3Regs;
  TMon3Regs = record
    case integer of
    0: (EAX,EBX,ECX,EDX,ESI,EDI,EBP,ESP: longint;
        SS,DS,ES,FS,GS,IP,CS,FLAGS,EFLAGS: word);
    1: (AX,HAX,BX,HBX,CX,HCX,DX,HDX,SI,HSI,DI,HDI,BP,HBP,SP,HSP: word);
    2: (AL,AH,HAL,HAH,BL,BH,HBL,HBH,CL,CH,HCL,HCH,DL,DH,HDL,HDH: byte);
    3: (X:array[1..42] of byte;
        CSIP:pointer);
  end;

function  MON3_Init( vfpUsrBreak, vfpUsrStack: pointer ): integer;
function  MON3_Done: integer;
function  MON3_SetBreakpoint( vfpBreakAddress: pointer;
                              wBreakNumber, wBreakType: word ): integer;
function  MON3_ClearBreakpoint( wBreakNumber: word ): integer;
function  MON3_SetSingleStep: integer;
function  MON3_ClearSingleStep: integer;

implementation

function  MON3_Init( vfpUsrBreak, vfpUsrStack: pointer ): integer; external;
function  MON3_Done: integer; external;
function  MON3_SetBreakpoint( vfpBreakAddress: pointer;
                              wBreakNumber, wBreakType: word ): integer; external;
function  MON3_ClearBreakpoint( wBreakNumber: word ): integer; external;
function  MON3_SetSingleStep: integer; external;
function  MON3_ClearSingleStep: integer; external;
{$L MON386}

end.
